/* Analyse The Brake!(tm) Mailer EMSI log */

  call RxFuncAdd "SysFileTree", "RexxUtil", "SysFileTree"
  call RxFuncAdd "SysFileDelete", "RexxUtil", "SysFileDelete"

  "@Echo off"
  FidoNet 	= Value( "FIDONET",, "OS2ENVIRONMENT" )
  FidoDir 	= Value( "FIDODIR",, "OS2ENVIRONMENT" )
  TmpDir        = Value( "TMP",, "OS2ENVIRONMENT" )
  SquishDir 	= FidoDir"\Squish"
  CmdDir        = FidoDir"\Cmd"

  /* ᫨ 㦭  pᯨ,  ⠭樨  */
  LongFormat	= 1

  /* 砩 p  ᫥ */
  QuoteFile	= CmdDir"\Quote.Txt"

  StationName	= "NafteBaza"
  LogDir	= FidoNet"\Logs"
  BrLog.1	= LogDir"\Brake1.ems"
  BrLog.2	= LogDir"\Brake2.ems"
  BrLog.3	= LogDir"\Brake3.ems"
  BrLog.4	= LogDir"\Brake4.ems"
  BrLog.0	= 4

  /*  BinkD ⮦ ⨬ ⨪  */
  NeedBinkD     = 1
  BinkDLog.1    = FidoDir"\Logs\BinkD.Log"
  BinkDLog.0    = 1

  Array.0	= 0
  MailerArray.0 = 0

  DateBegin     = ""
  DateEnd       = ""

  GroupArray.1.Name     = "The Brake!(tm) Mailer"
  GroupArray.2.Name	= "FhMail"
  GroupArray.3.Name	= "Argus"
  GroupArray.4.Name	= "T-Mail"
  GroupArray.5.Name     = "Xenia Mailer"
  GroupArray.6.Name	= "FIPS"
  GroupArray.7.Name	= "BT"
  GroupArray.8.Name     = "Terminate"
  GroupArray.8.Name     = "BinkD"

  curdir = Directory()
  rc = Directory( CmdDir )

  /*
  call sem_que.cmd request EMSILOG
  if result<=2 then do
  */

/*
07/01/97 17:11:07 [2] From
`EMSI_DAT0192
{EMSI}
{2:5020/69@fidonet 2:5020/69.1@fidonet 2:5020/69.2@fidonet 2:5020/69.3@fidonet 2:5020/69.10@fidonet 2:5020/69.100@fidonet 2:5020/69.101@fidonet 2:5020/69.102@fidonet 7:1130/69@fidonet}
{}
{8N1,RH1}
{HYD,ARC,XMA,FNC}
{1B}
{BT}
{2.60XE}
{Gamma9610132100IBM C++/i586}
{IDENT}
{[DialogueScience #10][Moscow, Russia][Boris Chernivetsky][193*233*210*136][115200][XA,CM,TCP,IFC,HUB]}
{TRX#}
{[32D29200]}
{MOH#}
{[0]}
????'

08/09/98 03:45:22 [3] From
`EMSI_DAT01B4
{EMSI}
{2:454/11@FidoNet 2:454/11.1@FidoNet 2:454/1.36@FidoNet 2:454/2.414@FidoNet 2:454/6.30@FidoNet 2:454/9.600@FidoNet 2:454/10.5@FidoNet 2:454/10.414@FidoNet}
{}
{8N1,PUA,RH1}
{HYD,DZA,ZAP,ZMO,NRQ,XMA}
{101}
{The Brake!(tm) Mailer}
{718.a8}
{9999}
{TB!REG}
{[Beta test TEAM]}
{TRX#}
{[35f4a838]}
{TZ}
{[-180]}
{TRAF}
{0 0}
{MOH#}
{[0]}
{IDENT}
{[Jeweller BBS][Brest city, Belarus][Vladyslav Yakubovich][375-162-265808][1.5Mb][V32B,V42B,XA,U,TUd]}
????'

*/
    /* The Brake!(tm) Mailer */
    do i=1 to BrLog.0
      LogCurrent = BrLog.i

      /* Analyse Logfile for all string */
      rc = Stream( LogCurrent, "c", "open read" )
      do while Lines( LogCurrent )
        Str = LineIn( LogCurrent )
        Parse Var Str eDate eTime eLine eType eStr
        if eType="From" then do
           if DateBegin="" then DateBegin = eDate eTime
           DateEnd = eDate eTime
           eMailer = GetMailerStr( eStr )
           eStation = GetStationStr( eStr )
           if eMailer<>"" then rc = AddToArray( eMailer, eStation )
        end
      end
      rc = LineOut( LogCurrent )
    end

    /* BinkD */
    If NeedBinkD then do
      do i=1 to BinkDLog.0
        LogCurrent = BinkDLog.i

        /* Analyse Logfile for all string */
        SYSName = ""; VERName = ""
        rc = Stream( LogCurrent, "c", "open read" )
        do while Lines( LogCurrent )
          Str = SubStr( LineIn( LogCurrent ), 3 )
          Parse Var Str eDate eMonth eTime eLine eType eName
          if eType="connected" then do
            SYSName = ""
            VERNAME = ""
          end
          if eType="SYS" then SYSName = eName
          if eType="VER" then do
            if SYSNAME<>"" then do
              VERName = eName
              rc = AddToArray( VERName, SYSName )
            end
            SYSName = ""
            VERNAME = ""
          end
        end
        rc = LineOut( LogCurrent )
      end
    end

    /* Output results */
    if Array.0>0 then do
      SAY
      SAY "Analyse from the first line" DateBegin "to the last" DateEnd
      SAY

      /* ⮢ ᭠砫  */
      rc = SortArray( 1, Array.0 )
      rc = BildMailerArray()

      /* 業⭮ ᮤঠ */
      rc = InitGroupArray()
      rc = BuildGroupArray()

      /*  ⨪ */
      AllConnect = 0
      SAY " "||Left( "", 61, "" )||Right( "", 11, "" )||""
      SAY " " Center( StationName" connections", 70 ) ""
      SAY " "||Left( "", 61, "" )||Right( "", 11, "" )||""
      do i=1 to MailerArray.0
        SAY " " Left( MailerArray.i.aMailer||" ", 60, "" )||Right( " "||MailerArray.i.aConnect, 10, "" ) ""
        AllConnect = AllConnect + MailerArray.i.aConnect
        if LongFormat=1 then
          do k=MailerArray.i.aBegin to MailerArray.i.aEnd
            SAY " " Left( "     "||Array.k.aStation, 60 )||Right( " "||Array.k.aConnect, 5 ) "     "
          end
      end
      SAY " "||Left( "", 61, "" )||Right( "", 11, "" )||""
      SAY " " Left( "  Summary connections ", 60, "" )||Right( " "||AllConnect, 10, "" ) ""
      SAY " "||Left( "", 61, "" )||Right( "", 11, "" )||""
      SAY

      /* ⥯ 業⭮ ᮤঠ 뢮 */
      SAY " "||Left( "", 61, "" )||Right( "", 11, "" )||""
      SAY " " Center( "Mailer's Raiting", 70 ) ""
      SAY " "||Left( "", 61, "" )||Right( "", 11, "" )||""
      do i=1 to GroupArray.0
        if GroupArray.i.Count <> 0 then do
          Str = " " Left( GroupArray.i.Name||" ", 55, "" )
          Str = Str||Right( " "GroupArray.i.Count, 5, "" )
          Str = Str||Right( " "||Format( GroupArray.i.Count*100/GroupArray.0.Count,,2 )||"%", 10 )" "
          SAY Str
        end
      end
      SAY " "||Left( "", 61, "" )||Right( "", 11, "" )||""
      SAY

      SAY "  " Center( "EMSI LogAnalyser, v1.0", 70 )
      SAY "  " Center( "(C)opyright by SPS//Landy, 1998, Brest, 2:454/8@FidoNet", 70 )
      SAY "  " Center( GetRandomQuote(), 70 )
      SAY
    end

  /*
  end
  rc = Directory( CmdDir )
  call sem_que.cmd release EMSILOG
  */
  rc = Directory( curdir )
  return 0

/*
  ⠥ 砩 p  Quote 䠩
*/
GetRandomQuote:
  QuoteStr = "Have a Good Day with The Brake!(tm) Mailer."
  qMin = 1
  qMax = Lines( QuoteFile )
  if qMax>0 then do
    qMax = 0
    do while Lines( QuoteFile )
      qMax = qMax + 1
      QuoteFileArray.qMax.qStr = LineIn( QuoteFile )
    end
    qRand = Random( qMin, qMax )
    QuoteStr = QuoteFileArray.qRand.qStr
    rc = LineOut( QuoteFile )
  end
  return QuoteStr

/*
  砫쭮 ᮧ ᨢ 㯯
*/
InitGroupArray: procedure Expose GroupArray.
  i=1
  do forever
    if GroupArray.i.Name="GROUPARRAY."||i||".NAME" then do
      GroupArray.i.Name  = "Other"
      GroupArray.i.Count = 0
      Leave
    end
    GroupArray.i.Count = 0
    i = i + 1
  end
  GroupArray.0 = i
  return 0

/*
  砫쭮 ᮧ ᨢ 㯯
*/
BuildGroupArray: procedure Expose GroupArray. MailerArray.
  GroupArray.0.Count = 0
  do i=1 to MailerArray.0
    fIndex = 0
    Parse Upper Var MailerArray.i.aMailer UpMailer
    do j=1 to GroupArray.0-1
    Parse Upper Var GroupArray.j.Name UpGroup
      Pos1 = Pos( UpGroup, UpMailer )
      if Pos1=1 then do
        fIndex = j
        Leave
      end
    end
    if fIndex=0 then fIndex = GroupArray.0
    Connects = MailerArray.i.aEnd - MailerArray.i.aBegin + 1
    GroupArray.fIndex.Count = GroupArray.fIndex.Count + Connects
    GroupArray.0.Count = GroupArray.0.Count + Connects
  end
  rc = SortGroupArray( 1, GroupArray.0 )
  return 0

/*
  pp ᨢ 㯯
*/
SortGroupArray: procedure Expose GroupArray.
  l = Arg(1); r = Arg(2)
  i = l; j = r; index = ( i+j ) % 2; Str = Right( 100000-GroupArray.index.Count, 5, "0")||GroupArray.index.Name
  do until i>j
    do while CompareStrings( Right( 100000-GroupArray.i.Count, 5, "0")||GroupArray.i.Name, Str ) < 0
      i = i + 1
    end
    do while CompareStrings( Str, Right( 100000-GroupArray.j.Count, 5, "0")||GroupArray.j.Name ) < 0
      j = j - 1
    end
    if i<j & CompareStrings( Right( 100000-GroupArray.i.Count, 5, "0")||GroupArray.i.Name, Right( 100000-GroupArray.j.Count, 5, "0")||GroupArray.j.Name )<>0 then do
      /*  ?.i -> y */
      y.1  = GroupArray.i.Name
      y.2  = GroupArray.i.Count
      /*  ?.j -> ?.i */
      GroupArray.i.Name     = GroupArray.j.Name
      GroupArray.i.Count    = GroupArray.j.Count
      /*  y -> ?.j */
      GroupArray.j.Name     = y.1
      GroupArray.j.Count    = y.2
    end
    if i<=j then do
      i = i + 1; j = j - 1
    end
  end
  if l < j then rc = SortGroupArray( l, j )
  if i < r then rc = SortGroupArray( i, r )
  return 0

/*
  p ᨢ 뫥p  ⮬ ᫠ ᮥ
*/
BildMailerArray: procedure Expose Array. MailerArray.
  LastMailer = Array.1.aMailer; LastConnect = Array.1.aConnect; LastBegin = 1
  do i=2 to Array.0
    if LastMailer = Array.i.aMailer then LastConnect = LastConnect + Array.i.aConnect
    else do
      fIndex = MailerArray.0 + 1
      MailerArray.0 = fIndex
      MailerArray.fIndex.aMailer  = LastMailer
      MailerArray.fIndex.aConnect = LastConnect
      MailerArray.fIndex.aBegin   = LastBegin
      MailerArray.fIndex.aEnd     = i-1
      LastMailer = Array.i.aMailer; LastConnect = Array.i.aConnect; LastBegin = i
    end
  end
  fIndex = MailerArray.0 + 1
  MailerArray.0 = fIndex
  MailerArray.fIndex.aMailer  = LastMailer
  MailerArray.fIndex.aConnect = LastConnect
  MailerArray.fIndex.aBegin   = LastBegin
  MailerArray.fIndex.aEnd     = i-1
  return 0

/*
  pp ᨢ p
*/
SortArray: procedure Expose Array.
  l = Arg(1); r = Arg(2)
  i = l; j = r; index = ( i+j ) % 2; Str = Array.index.aMailer||Array.index.aStation
  do until i>j
    do while CompareStrings( Array.i.aMailer||Array.i.aStation, Str ) < 0
      i = i + 1
    end
    do while CompareStrings( Str, Array.j.aMailer||Array.j.aStation ) < 0
      j = j - 1
    end
    if i<j & CompareStrings( Array.i.aMailer||Array.i.aStation, Array.j.aMailer||Array.j.aStation )\=0 then do
      /*  ?.i -> y */
      y.1  = Array.i.aMailer
      y.2  = Array.i.aStation
      y.3  = Array.i.aConnect
      /*  ?.j -> ?.i */
      Array.i.aMailer  = Array.j.aMailer
      Array.i.aStation = Array.j.aStation
      Array.i.aConnect = Array.j.aConnect
      /*  y -> ?.j */
      Array.j.aMailer  = y.1
      Array.j.aStation = y.2
      Array.j.aConnect = y.3
    end
    if i<=j then do
      i = i + 1; j = j - 1
    end
  end
  if l < j then rc = SortArray( l, j )
  if i < r then rc = SortArray( i, r )
  return 0

/*
  Compare string in upper and without space.
Arg:
 1 - Str1
 2 - Str2
Out:
 0 - if compare
*/
CompareStrings: Procedure
  Str.1 = Arg(1); Str.2 = Arg(2)
  Parse upper Var Str.1 Str.1
  Parse upper Var Str.2 Str.2
  DifBegin = Compare( Str.1, Str.2 )
  if DifBegin=0 then return 0
  else do
    Str.1.0 = Length( Str.1 ); Str.2.0 = Length( Str.2 )
    if DifBegin>Str.1.0 then return -1
    if DifBegin>Str.2.0 then return 1
    Str.1.Chr_ = C2D( SubStr( Str.1, DifBegin, 1 ) )
    Str.2.Chr_ = C2D( SubStr( Str.2, DifBegin, 1 ) )
    if Str.1.Chr_<Str.2.Chr_ then return -1
    else return 1
  end
  return 0

/*
  Hp騢 稪 ᮥ    
   ᨢ 뫥p  ⠭権
*/
AddToArray: procedure Expose Array.
  s1 = Arg(1)
  s2 = Arg(2)

  /*    諨 */
  fIndex = 0

  /*  ᥬ ⠬ ᨢ */
  do i=1 to Array.0
    if (Array.i.aMailer=s1) & (Array.i.aStation=s2) then do
      /* 諨 */
      fIndex = i
      Leave
    end
  end
  if fIndex=0 then do
    /*   */
    fIndex = Array.0 + 1
    Array.0 = fIndex
    Array.fIndex.aMailer = s1
    Array.fIndex.aStation = s2
    Array.fIndex.aConnect = 1
  end
  else
    /* 㦥  ⠪ */
    Array.fIndex.aConnect = Array.fIndex.aConnect + 1
  return 0

/*
  뤥  EMSI  뫥p
*/
GetMailerStr: procedure
  Str = Arg(1)
  do i=1 to 7
    Pos1 = Pos( "{", Str )
    if Pos1>0 then Str = SubStr( Str, Pos1+1 )
  end
  MailerName = ""
  VersionName = ""
  SubVersionName = ""
  Pos1 = Pos( "}", Str )
  if Pos1>0 then MailerName = Left( Str, Pos1-1 ); Str = SubStr( Str, Pos1+2 )
  Pos1 = Pos( "}", Str )
  if Pos1>0 then VersionName = Left( Str, Pos1-1 ); Str = SubStr( Str, Pos1+2 )
  Pos1 = Pos( "}", Str )
  if Pos1>0 then SubVersionName = Left( Str, Pos1-1 )
  Str = MailerName
  if VersionName<>"" then Str = Str VersionName
  if SubVersionName<>"" then Str = Str||"/"||SubVersionName
  return Str

/*
  뤥  EMSI  ⠭樨
*/
GetStationStr: procedure
  Str = Arg(1)
  StStr = ""
  Pos1 = Pos( "{IDENT}", Str )
  if Pos1>0 then do
    Str = SubStr( Str, Pos1+Length( "{IDENT}" )+2 )
    do i=1 to Length( Str )
      if SubStr( Str, i, 1 )="]" then do
        if SubStr( Str, i+1, 1 )="]" then do
          StStr = StStr||"]"; i=i+1
        end
        else Leave
      end
      else StStr = StStr||SubStr( Str, i, 1 )
    end
  end
  Parse Upper Var StStr UpStr
  if Pos( "BAD PASSWORD", UpStr )>0 then StStr="Bad Password"
  return StStr


